package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// BatchSelectIntegralReleaseInterpositionUserFlows 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `IntegralReleaseInterpositionUserFlowFindByParams` 方法
func BatchSelectIntegralReleaseInterpositionUserFlows(Db *xorm.Engine, params map[string]interface{}) (*[]model.IntegralReleaseInterpositionUserFlow, error) {
	var IntegralReleaseInterpositionUserFlowData []model.IntegralReleaseInterpositionUserFlow
	if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).
		Find(&IntegralReleaseInterpositionUserFlowData); err != nil {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &IntegralReleaseInterpositionUserFlowData, nil
}

// IntegralReleaseInterpositionUserFlowInsert 插入单条数据
func IntegralReleaseInterpositionUserFlowInsert(session *xorm.Session, IntegralReleaseInterpositionUserFlow *model.IntegralReleaseInterpositionUserFlow) (int, error) {
	_, err := session.InsertOne(IntegralReleaseInterpositionUserFlow)
	if err != nil {
		return 0, err
	}
	return IntegralReleaseInterpositionUserFlow.Id, nil
}

// BatchAddIntegralReleaseInterpositionUserFlows 批量新增数据
func BatchAddIntegralReleaseInterpositionUserFlows(Db *xorm.Engine, IntegralReleaseInterpositionUserFlowData []*model.IntegralReleaseInterpositionUserFlow) (int64, error) {
	affected, err := Db.Insert(IntegralReleaseInterpositionUserFlowData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetIntegralReleaseInterpositionUserFlowCount(Db *xorm.Engine) int {
	var IntegralReleaseInterpositionUserFlow model.IntegralReleaseInterpositionUserFlow
	session := Db.Where("")
	count, err := session.Count(&IntegralReleaseInterpositionUserFlow)
	if err != nil {
		return 0
	}
	return int(count)
}
func GetIntegralReleaseInterpositionUserFlowSum(sess *xorm.Session, uid int, coinId int, ordId string) float64 {
	var IntegralReleaseInterpositionUserFlow model.IntegralReleaseInterpositionUserFlow
	count, err := sess.Where("uid=? and coin_id=? and ord_id=? and kind=?", uid, coinId, ordId, 0).Sum(&IntegralReleaseInterpositionUserFlow, "amount")
	if err != nil {
		return 0
	}
	return count
}

// IntegralReleaseInterpositionUserFlowDelete 删除记录
func IntegralReleaseInterpositionUserFlowDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.IntegralReleaseInterpositionUserFlow{})
	} else {
		return Db.Where("id = ?", id).Delete(model.IntegralReleaseInterpositionUserFlow{})
	}
}

// IntegralReleaseInterpositionUserFlowUpdate 更新记录
func IntegralReleaseInterpositionUserFlowUpdate(session *xorm.Session, id interface{}, IntegralReleaseInterpositionUserFlow *model.IntegralReleaseInterpositionUserFlow, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = session.Where("id=?", id).Cols(forceColums...).Update(IntegralReleaseInterpositionUserFlow)
	} else {
		affected, err = session.Where("id=?", id).Update(IntegralReleaseInterpositionUserFlow)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// IntegralReleaseInterpositionUserFlowGetOneByParams 通过传入的参数查询数据(单条)
func IntegralReleaseInterpositionUserFlowGetOneByParams(session *xorm.Session, params map[string]interface{}) (*model.IntegralReleaseInterpositionUserFlow, error) {
	var m model.IntegralReleaseInterpositionUserFlow
	var query = fmt.Sprintf("%s =?", params["key"])
	has, err := session.Where(query, params["value"]).Get(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, errors.New("未查询到相应的 block_star_chain 记录")
	}
	return &m, nil
}

// IntegralReleaseInterpositionUserFlowFindByParams 通过传入的参数查询数据(多条)
func IntegralReleaseInterpositionUserFlowFindByParams(Db *xorm.Engine, params map[string]interface{}) (*[]model.IntegralReleaseInterpositionUserFlow, error) {
	var m []model.IntegralReleaseInterpositionUserFlow
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := Db.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}

func IntegralReleaseInterpositionUserFlowFindByParamsByPage(Db *xorm.Engine, params map[string]interface{}, page, pageSize int) (*[]model.IntegralReleaseInterpositionUserFlow, error) {
	var m []model.IntegralReleaseInterpositionUserFlow
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if page == 0 && pageSize == 0 {
		page = 1
		pageSize = 10
	}

	if params["key"] == nil {
		//查询全部数据
		err := Db.Limit(pageSize, (page-1)*pageSize).Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
