package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"reflect"
	"xorm.io/xorm"
)

// BatchSelectNiuBeiCoinBasics 批量查询数据 TODO::和下面的方法重复了，建议采用下面的 `NiuBeiCoinBasicFindByParams` 方法
func BatchSelectNiuBeiCoinBasics(session *xorm.Session, params map[string]interface{}) (*[]model.NiuBeiCoinBasic, error) {
	var NiuBeiCoinBasicData []model.NiuBeiCoinBasic
	if err := session.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).
		Find(&NiuBeiCoinBasicData); err != nil {
		return nil, zhios_order_relate_logx.Warn(err)
	}
	return &NiuBeiCoinBasicData, nil
}

// NiuBeiCoinBasicInsert 插入单条数据
func NiuBeiCoinBasicInsert(Db *xorm.Engine, NiuBeiCoinBasic *model.NiuBeiCoinBasic) (int, error) {
	_, err := Db.InsertOne(NiuBeiCoinBasic)
	if err != nil {
		return 0, err
	}
	return NiuBeiCoinBasic.Id, nil
}

// BatchAddNiuBeiCoinBasics 批量新增数据
func BatchAddNiuBeiCoinBasics(Db *xorm.Engine, NiuBeiCoinBasicData []*model.NiuBeiCoinBasic) (int64, error) {
	affected, err := Db.Insert(NiuBeiCoinBasicData)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func GetNiuBeiCoinBasicCount(Db *xorm.Engine) int {
	var NiuBeiCoinBasic model.NiuBeiCoinBasic
	session := Db.Where("")
	count, err := session.Count(&NiuBeiCoinBasic)
	if err != nil {
		return 0
	}
	return int(count)
}

// NiuBeiCoinBasicDelete 删除记录
func NiuBeiCoinBasicDelete(Db *xorm.Engine, id interface{}) (int64, error) {
	if reflect.TypeOf(id).Kind() == reflect.Slice {
		return Db.In("id", id).Delete(model.NiuBeiCoinBasic{})
	} else {
		return Db.Where("id = ?", id).Delete(model.NiuBeiCoinBasic{})
	}
}

// NiuBeiCoinBasicUpdate 更新记录
func NiuBeiCoinBasicUpdate(session *xorm.Session, id interface{}, NiuBeiCoinBasic *model.NiuBeiCoinBasic, forceColums ...string) (int64, error) {
	var (
		affected int64
		err      error
	)
	if forceColums != nil {
		affected, err = session.Where("id=?", id).Cols(forceColums...).Update(NiuBeiCoinBasic)
	} else {
		affected, err = session.Where("id=?", id).Update(NiuBeiCoinBasic)
	}
	if err != nil {
		return 0, err
	}
	return affected, nil
}

// NiuBeiCoinBasicGetOneByParams 通过传入的参数查询数据(单条)
func NiuBeiCoinBasicGetOneByParams(session *xorm.Session, params map[string]interface{}) (*model.NiuBeiCoinBasic, error) {
	var m model.NiuBeiCoinBasic
	var query = fmt.Sprintf("%s =?", params["key"])
	has, err := session.Where(query, params["value"]).Get(&m)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, errors.New("未查询到相应的 block_star_chain 记录")
	}
	return &m, nil
}

// NiuBeiCoinBasicFindByParams 通过传入的参数查询数据(多条)
func NiuBeiCoinBasicFindByParams(Db *xorm.Engine, params map[string]interface{}) (*[]model.NiuBeiCoinBasic, error) {
	var m []model.NiuBeiCoinBasic
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if params["key"] == nil {
		//查询全部数据
		err := Db.Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}

func NiuBeiCoinBasicFindByParamsByPage(Db *xorm.Engine, params map[string]interface{}, page, pageSize int) (*[]model.NiuBeiCoinBasic, error) {
	var m []model.NiuBeiCoinBasic
	if params["value"] == nil {
		return nil, errors.New("参数有误")
	}
	if page == 0 && pageSize == 0 {
		page = 1
		pageSize = 10
	}

	if params["key"] == nil {
		//查询全部数据
		err := Db.Limit(pageSize, (page-1)*pageSize).Find(&m)
		if err != nil {
			return nil, zhios_order_relate_logx.Error(err)
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m); err != nil {
				return nil, zhios_order_relate_logx.Warn(err)
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Limit(pageSize, (page-1)*pageSize).Find(&m)
			if err != nil {
				return nil, zhios_order_relate_logx.Error(err)
			}
			return &m, nil
		}

	}
}
