package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/md"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	"errors"
	"fmt"
	"reflect"
	"strings"
	"xorm.io/xorm"
)

type RegionalAgentUserBelongWithSession struct {
	Session                 *xorm.Session
	RegionalAgentUserBelong *model.RegionalAgentUserBelong
}

// 联表查询
type RegionalAgentUserBelongJoinUser struct {
	model.RegionalAgentUserBelong `xorm:"extends"`
	model.User                    `xorm:"extends"`
	model.UserLevel               `xorm:"extends"`
	model.UserProfile             `xorm:"extends"`
}

// 单条记录插入
func (rab RegionalAgentUserBelongWithSession) InsertOne() error {
	_, err := rab.Session.InsertOne(rab.RegionalAgentUserBelong)
	if err != nil {
		return err
	}
	return nil
}

// 多条记录插入
func (rab RegionalAgentUserBelongWithSession) InsertMulti(belong []model.RegionalAgentUserBelong) error {
	_, err := rab.Session.Table("regional_agent_user_belong").InsertMulti(belong)
	if err != nil {
		return err
	}
	return nil
}

// 跟pvd和uid更新
func (rab RegionalAgentUserBelongWithSession) UpdateRegionalAgentUserBelong(cols ...string) (bool, error) {
	_, err := rab.Session.Table("regional_agent_user_belong").
		Where("id = ? ", rab.RegionalAgentUserBelong.Id).
		Cols(cols...).
		Update(rab.RegionalAgentUserBelong)
	/*Where("uid = ? AND pvd = '?' is_use = ?", rab.RegionalAgentUserBelong.Uid, rab.RegionalAgentUserBelong.Pvd).
	Update(rab.RegionalAgentUserBelong)*/
	if err != nil {
		return false, err
	}
	return true, nil
}

//
func (rab RegionalAgentUserBelongWithSession) GetOneRecordByUidAndRegionId() (bool, error) {
	isHas, err := rab.Session.Table("regional_agent_user_belong").
		Where("uid = ? AND pvd = 'COMMON' AND is_use = 1", rab.RegionalAgentUserBelong.Uid).
		Get(rab.RegionalAgentUserBelong)
	sql, _ := rab.Session.LastSQL()
	fmt.Printf("123 %s\n uid: %s\n", sql, rab.RegionalAgentUserBelong.Uid)
	if err != nil {
		return false, err
	}
	return isHas, nil
}

// 获取代理区域所有会员
func (rab RegionalAgentUserBelongWithSession) GetAllRegionalAgentUserBelong(condition string, page, pageSize int, keyword,
	sort, commissionSort, orderSort, userLevel string) (*[]RegionalAgentUserBelongJoinUser, error) {
	if page == 0 && pageSize == 0 {
		page = 1
		pageSize = 10
	}
	var userBelongList []RegionalAgentUserBelongJoinUser
	userJoinCondition := ""
	orderBy := ""
	//groupBy := ""
	selectColumn := "*"
	if keyword != "" {
		userJoinCondition = " AND (phone like '%" + keyword + "%' OR nickname like '%" + keyword + "%')"
	}

	if sort != "" {
		selectColumn += ",count(user_relate.parent_uid) as sort"
		orderBy += "sort " + sort + ","
	}
	if commissionSort != "" {
		orderBy += "user_profile.fin_commission " + commissionSort + ","
	}
	if orderSort != "" {
		selectColumn += ", count(regional_agent_user_ord.uid) as order_count,"
		orderBy += "order_count " + orderSort + ","
	}
	if userLevel != "" {
		condition += " AND regional_agent_user_belong.user_level = " + userLevel
		orderBy += "regional_agent_user_belong.create_time DESC"
	}
	orderBy = strings.TrimRight(orderBy, ",")
	selectColumn = strings.TrimRight(selectColumn, ",")
	//rab.Session.Join("INNER", "user_relate", "")
	rab.Session.Join("INNER", "user", "regional_agent_user_belong.uid = user.uid"+userJoinCondition)
	rab.Session.Join("INNER", "user_level", "user.level = user_level.id")
	rab.Session.Join("INNER", "user_profile", "regional_agent_user_belong.uid = user_profile.uid")
	rab.Session.Join("LEFT", "regional_agent_user_ord", "regional_agent_user_belong.uid = regional_agent_user_ord.uid")
	rab.Session.Join("LEFT", "user_relate", "regional_agent_user_ord.uid = user_relate.parent_uid")
	err := rab.Session.Select(selectColumn).Table("regional_agent_user_belong").
		Where(condition).
		GroupBy("regional_agent_user_belong.uid").
		Limit(pageSize, (page-1)*pageSize).
		OrderBy(orderBy).
		Find(&userBelongList)
	if err != nil {
		return nil, err
	}
	return &userBelongList, nil
}

// 根据pvd查询
func (rab RegionalAgentUserBelongWithSession) GetRegionalAgentUserBelongByUidAndPvd() (bool, error) {
	//var belong *model.RegionalAgentUserBelong
	isHas, err := rab.Session.Table("regional_agent_user_belong").
		Get(rab.RegionalAgentUserBelong)
	sql, _ := rab.Session.LastSQL()
	fmt.Printf("%s\n", sql)
	if err != nil {
		return false, err
	}
	return isHas, nil
}

// 根据用户id查找用户加入的所有网点
func (rab RegionalAgentUserBelongWithSession) GetRegionalAgentUserBelongByUid() ([]*model.RegionalAgentUserBelong, error) {
	var list []*model.RegionalAgentUserBelong
	err := rab.Session.Table("regional_agent_user_belong").Where("uid = ? AND is_use = 1", rab.RegionalAgentUserBelong.Uid).Find(&list)
	if err != nil {
		return nil, err
	}
	return list, nil
}

func GetCountByRegionalAgentUserBelong(Db *xorm.Engine, condition string) int {
	var RegionalAgentUserBelong model.RegionalAgentUserBelong
	session := Db.Where(condition)
	count, err := session.Count(&RegionalAgentUserBelong)
	if err != nil {
		return 0
	}
	return int(count)
}

// GetCountByRegionalAgentUserBelongByParams 通过传入的参数查询数据(单条)
func GetCountByRegionalAgentUserBelongByParams(Db *xorm.Engine, uid interface{}, params map[string]interface{}) (*model.RegionalAgentUserBelong, error) {
	var m model.RegionalAgentUserBelong
	var query = fmt.Sprintf("%s =?", params["key"])
	if has, err := Db.Where("uid = ?", uid).Where(query, params["value"]).Get(&m); err != nil || has == false {
		return nil, err
	}
	return &m, nil
}

// GetCountByRegionalAgentUserBelong 通过传入的参数查询数据(单条)
func GetCountByRegionalAgentUserBelongById(Db *xorm.Engine, uid interface{}, pvd string, newPvd string) (*model.RegionalAgentUserBelong, error) {
	var m model.RegionalAgentUserBelong
	if newPvd == md.PVD_COMMON { //公共的
		pvd = newPvd
	}
	if pvd == md.PVD_USER_LV_UP || pvd == md.PVD_CARD {
		pvd = md.PVD_COMMON
	}
	fmt.Println(pvd)
	if pvd == md.PVD_COMMON {
		if has, err := Db.Where("uid = ? and (pvd='' or pvd=?)", uid, pvd).Get(&m); err != nil || has == false {
			return nil, err
		}
		return &m, nil
	} else {
		if has, err := Db.Where("uid = ? and pvd=?", uid, pvd).Get(&m); err != nil || has == false {
			return nil, err
		}
		return &m, nil
	}
}

// RegionalAgentOrdBelongInsert 插入单条数据
func RegionalAgentOrdBelongInsert(Db *xorm.Engine, regionalAgentRegion *model.RegionalAgentOrdBelong) (int64, error) {
	_, err := Db.InsertOne(regionalAgentRegion)
	if err != nil {
		return 0, err
	}
	return regionalAgentRegion.Id, nil
}

// RegionalAgentRegionGetOneByParams 通过传入的参数查询数据(单条)
func RegionalAgentRegionGetOneByParams(Db *xorm.Engine, params map[string]interface{}) (*model.RegionalAgentRegion, error) {
	var m model.RegionalAgentRegion
	var query = fmt.Sprintf("%s =?", params["key"])
	if has, err := Db.Where(query, params["value"]).Get(&m); err != nil || has == false {
		return nil, err
	}
	return &m, nil
}

func RegionalAgentUserFindByValid(Db *xorm.Engine, regionId string) (*[]model.RegionalAgentUser, error) {
	var m []model.RegionalAgentUser
	err := Db.Where("region_id=? and deleted_time IS NULL", regionId).Find(&m)
	if err != nil {
		return nil, err
	}
	return &m, nil
}

// GetCountByRegionalAgentBase 通过传入的参数查询数据(单条)
func GetCountByRegionalAgentBase(Db *xorm.Engine) (*model.RegionalAgentBase, error) {
	var m model.RegionalAgentBase
	get, err := Db.Get(&m)
	if err != nil {
		return &m, err
	}
	if !get {
		return &m, errors.New("无")
	}
	return &m, nil
}

// VirtualCoinFindByParams 通过传入的参数查询数据(多条)
func VirtualCoinFindByParams(Db *xorm.Engine, params map[string]interface{}) (*[]model.VirtualCoin, error) {
	var m []model.VirtualCoin
	if params["key"] == nil {
		//查询全部数据
		err := Db.Find(&m)
		if err != nil {
			return nil, err
		}
		return &m, nil
	} else {
		if reflect.TypeOf(params["value"]).Kind() == reflect.Slice {
			//指定In查询
			if err := Db.In(zhios_order_relate_utils.AnyToString(params["key"]), params["value"]).Find(&m); err != nil {
				return nil, err
			}
			return &m, nil
		} else {
			var query = fmt.Sprintf("%s =?", params["key"])
			err := Db.Where(query, params["value"]).Find(&m)
			if err != nil {
				return nil, err
			}
			return &m, nil
		}

	}
}
func RegionalAgentCalcSystemRelateInsert(Db *xorm.Engine, regionalAgentCalcSystemRelate *model.RegionalAgentCalcSystemRelate) (int64, error) {
	_, err := Db.InsertOne(regionalAgentCalcSystemRelate)
	if err != nil {
		return 0, err
	}
	return regionalAgentCalcSystemRelate.Id, nil
}

// GetCountByRegionalAgentSchemeInfoByParams 通过传入的参数查询数据(单条)
func GetCountByRegionalAgentSchemeInfoByParams(Db *xorm.Engine, params map[string]interface{}) (*model.RegionalAgentScheme, error) {
	var m model.RegionalAgentScheme
	var query = fmt.Sprintf("%s =?", params["key"])
	if has, err := Db.Where(query, params["value"]).Get(&m); err != nil || has == false {
		return nil, err
	}
	return &m, nil
}
