package model

type PlanReward struct {
	Id               int     `json:"id" xorm:"not null pk autoincr INT(10)"`
	Pvd              string  `json:"pvd" xorm:"not null comment('供应商') unique VARCHAR(255)"`
	PvdRate          float32 `json:"pvd_rate" xorm:"not null default 0.0000 comment('供应商抽成比例') FLOAT(6,4)"`
	SysRate          float32 `json:"sys_rate" xorm:"not null default 0.0000 comment('平台抽成比例') FLOAT(6,4)"`
	RegionRate       float32 `json:"region_rate" xorm:"not null default 0.0000 comment('区域代理抽成比例') FLOAT(6,4)"`
	GlobalRate       float32 `json:"global_rate" xorm:"not null default 0.0000 comment('全球分红抽成比例') FLOAT(6,4)"`
	SettleMode       int     `json:"settle_mode" xorm:"not null default 1 comment('0.手动方案,1.自动方案') TINYINT(1)"`
	PlanCommissionId int     `json:"plan_commission_id" xorm:"not null default 0 comment('佣金方案0未设置,>0对应方案') TINYINT(3)"`
	PlanSettleId     int     `json:"plan_settle_id" xorm:"not null default 0 comment('结算方案0未设置,>0对应方案') TINYINT(3)"`
	State            int     `json:"state" xorm:"not null default 1 comment('0关闭,1开启') TINYINT(1)"`
	SubsidyRate      float32 `json:"subsidy_rate" xorm:"not null default 0.0000 comment('待删除字段') FLOAT(6,4)"`
	Source           int     `json:"source" xorm:"not null default 1 comment('佣金来源：1联盟佣金 2补贴金额') TINYINT(1)"`
	AppType          int     `json:"app_type" xorm:"not null default 1 comment('所属应用：1导购 2自营 4O2O') TINYINT(3)"`
	MerchantRate     float32 `json:"merchant_rate" xorm:"not null default 0.0000 comment('o2o商家抽成比例') FLOAT(6,4)"`
	NewAgentRate     float32 `json:"new_agent_rate" xorm:"not null default 0.0000 comment('') FLOAT(6,4)"`
	PushHandRate     float32 `json:"push_hand_rate" xorm:"not null default 0.0000 comment('o2o推手抽成比例') FLOAT(6,4)"`
	OrderBeforeRate  float32 `json:"order_before_rate" xorm:"not null default 0.0000 comment('下单前的联盟抽成') FLOAT(6,4)"`
	IntegralOpen     int     `json:"integral_open" xorm:"not null default 0 comment('积分抽成') TINYINT(1)"`
}
