package model

import (
	"time"
)

type RegionalAgentScheme struct {
	Id                        int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	Name                      string    `json:"name" xorm:"comment('方案名称') VARCHAR(255)"`
	Comment                   string    `json:"comment" xorm:"comment('备注') VARCHAR(2048)"`
	IsUse                     int       `json:"is_use" xorm:"not null default 0 comment('是否使用') TINYINT(1)"`
	AgentType                 int       `json:"agent_type" xorm:"not null comment('（1省级代理2市级代理3县，区代理4网点代理）') TINYINT(1)"`
	Label                     string    `json:"label" xorm:"not null default '0' comment('别名，给前端使用') VARCHAR(255)"`
	IsUnify                   int       `json:"is_unify" xorm:"not null default 0 comment('是否统一佣金比例（否：0；是：1）') TINYINT(1)"`
	UnifyCommissionRate       string    `json:"unify_commission_rate" xorm:"not null default 0.0000 comment('统一佣金比例') DECIMAL(6,4)"`
	FistAutoAudit             int       `json:"fist_auto_audit" xorm:"not null default 1 comment('初次购买审核方式（1自动，2手动）') TINYINT(1)"`
	RenewalAutoAudit          int       `json:"renewal_auto_audit" xorm:"not null default 0 comment('续费审核方式（1自动，2手动）') TINYINT(1)"`
	IsUnifyAgentPrice         int       `json:"is_unify_agent_price" xorm:"default 0 comment('是否统一代理价格（1统一价格，2按区域设置不用价格）') TINYINT(1)"`
	LevelUpdateCondition      int       `json:"level_update_condition" xorm:"default 0 comment('1是无条件升级,2是条件升级,3是组合条件升级') TINYINT(1)"`
	FinishTaskNum             int       `json:"finish_task_num" xorm:"default 0 comment('完成任务数量（如果是组合条件，则该数指的是完成几组）') INT(11)"`
	AgentDate                 int       `json:"agent_date" xorm:"not null default 0 comment('代理有效期（0永久有效，单位月）') INT(11)"`
	IsRenewal                 int       `json:"is_renewal" xorm:"not null comment('是否开启续费功能（否：0；是：1）') TINYINT(1)"`
	RenewalAgPrice            string    `json:"renewal_ag_price" xorm:"comment('续费永久代理价格') DECIMAL(12,2)"`
	RenewalMonthAgPrice       string    `json:"renewal_month_ag_price" xorm:"default 0.00 comment('续费月代理价格') DECIMAL(12,2)"`
	RenewalQuarterAgPrice     string    `json:"renewal_quarter_ag_price" xorm:"comment('续费季度代理价格') DECIMAL(12,2)"`
	RenewalYearAgPrice        string    `json:"renewal_year_ag_price" xorm:"comment('续费年代理价格') DECIMAL(12,2)"`
	RewardCoins               string    `json:"reward_coins" xorm:"comment('奖励虚拟币设置') TEXT"`
	IsReward                  int       `json:"is_reward" xorm:"not null comment('代理奖励（1:开启,2:关闭）') TINYINT(1)"`
	CreateTime                time.Time `json:"create_time" xorm:"not null default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
	UpdateTime                time.Time `json:"update_time" xorm:"not null default 'CURRENT_TIMESTAMP' comment('更新时间') DATETIME"`
	IsUnifyCommissionReturn   int       `json:"is_unify_commission_return" xorm:"not null default 0 comment('统一返佣金比例（是：0；否：1）') TINYINT(1)"`
	UnifyCommissionReturnRate string    `json:"unify_commission_return_rate" xorm:"not null default 0.0000 comment('统一返佣金比例') DECIMAL(6,4)"`
	IsUnifyLimmitPersion      int       `json:"is_unify_limmit_persion" xorm:"not null default 0 comment('统一限制人数（是：0；否：1）') TINYINT(1)"`
	UnifyLimmitPersion        string    `json:"unify_limmit_persion" xorm:"not null default 0 comment('统一限制人数') VARCHAR(50)"`
}
